"use strict";
// 
// Generated by @himenon/openapi-typescript-code-generator v0.13.2
// 
// OpenApi : 3.0.0
// 
// 
Object.defineProperty(exports, "__esModule", { value: true });
exports.Client = void 0;
class Client {
    constructor(apiClient, baseUrl) {
        this.apiClient = apiClient;
        this.baseUrl = baseUrl.replace(/\/$/, "");
    }
    /**
     * ListAccounts returns the list of accounts
     * operationId: AccountService_ListAccounts
     * Request URI: /api/v1/account
     */
    async AccountService_ListAccounts(option) {
        const url = this.baseUrl + `/api/v1/account`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * CanI checks if the current account has permission to perform an action
     * operationId: AccountService_CanI
     * Request URI: /api/v1/account/can-i/{resource}/{action}/{subresource}
     */
    async AccountService_CanI(params, option) {
        const url = this.baseUrl + `/api/v1/account/can-i/${params.parameter.resource}/${params.parameter.action}/${params.parameter.subresource}`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * UpdatePassword updates an account's password to a new value
     * operationId: AccountService_UpdatePassword
     * Request URI: /api/v1/account/password
     */
    async AccountService_UpdatePassword(params, option) {
        const url = this.baseUrl + `/api/v1/account/password`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * GetAccount returns an account
     * operationId: AccountService_GetAccount
     * Request URI: /api/v1/account/{name}
     */
    async AccountService_GetAccount(params, option) {
        const url = this.baseUrl + `/api/v1/account/${params.parameter.name}`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * CreateToken creates a token
     * operationId: AccountService_CreateToken
     * Request URI: /api/v1/account/{name}/token
     */
    async AccountService_CreateToken(params, option) {
        const url = this.baseUrl + `/api/v1/account/${params.parameter.name}/token`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * DeleteToken deletes a token
     * operationId: AccountService_DeleteToken
     * Request URI: /api/v1/account/{name}/token/{id}
     */
    async AccountService_DeleteToken(params, option) {
        const url = this.baseUrl + `/api/v1/account/${params.parameter.name}/token/${params.parameter.id}`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List returns list of applications
     * operationId: ApplicationService_List
     * Request URI: /api/v1/applications
     */
    async ApplicationService_List(params, option) {
        const url = this.baseUrl + `/api/v1/applications`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            name: { value: params.parameter.name, explode: false },
            refresh: { value: params.parameter.refresh, explode: false },
            project: { value: params.parameter.project, explode: true },
            resourceVersion: { value: params.parameter.resourceVersion, explode: false },
            selector: { value: params.parameter.selector, explode: false },
            repo: { value: params.parameter.repo, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create creates an application
     * operationId: ApplicationService_Create
     * Request URI: /api/v1/applications
     */
    async ApplicationService_Create(params, option) {
        const url = this.baseUrl + `/api/v1/applications`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        const queryParameters = {
            upsert: { value: params.parameter.upsert, explode: false },
            validate: { value: params.parameter.validate, explode: false }
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, queryParameters, option);
    }
    /**
     * Update updates an application
     * operationId: ApplicationService_Update
     * Request URI: /api/v1/applications/{application.metadata.name}
     */
    async ApplicationService_Update(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter["application.metadata.name"]}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        const queryParameters = {
            validate: { value: params.parameter.validate, explode: false }
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, queryParameters, option);
    }
    /**
     * ManagedResources returns list of managed resources
     * operationId: ApplicationService_ManagedResources
     * Request URI: /api/v1/applications/{applicationName}/managed-resources
     */
    async ApplicationService_ManagedResources(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.applicationName}/managed-resources`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            namespace: { value: params.parameter.namespace, explode: false },
            name: { value: params.parameter.name, explode: false },
            version: { value: params.parameter.version, explode: false },
            group: { value: params.parameter.group, explode: false },
            kind: { value: params.parameter.kind, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * ResourceTree returns resource tree
     * operationId: ApplicationService_ResourceTree
     * Request URI: /api/v1/applications/{applicationName}/resource-tree
     */
    async ApplicationService_ResourceTree(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.applicationName}/resource-tree`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            namespace: { value: params.parameter.namespace, explode: false },
            name: { value: params.parameter.name, explode: false },
            version: { value: params.parameter.version, explode: false },
            group: { value: params.parameter.group, explode: false },
            kind: { value: params.parameter.kind, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get returns an application by name
     * operationId: ApplicationService_Get
     * Request URI: /api/v1/applications/{name}
     */
    async ApplicationService_Get(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            refresh: { value: params.parameter.refresh, explode: false },
            project: { value: params.parameter.project, explode: true },
            resourceVersion: { value: params.parameter.resourceVersion, explode: false },
            selector: { value: params.parameter.selector, explode: false },
            repo: { value: params.parameter.repo, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Delete deletes an application
     * operationId: ApplicationService_Delete
     * Request URI: /api/v1/applications/{name}
     */
    async ApplicationService_Delete(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            cascade: { value: params.parameter.cascade, explode: false },
            propagationPolicy: { value: params.parameter.propagationPolicy, explode: false }
        };
        return this.apiClient.request("DELETE", url, headers, undefined, queryParameters, option);
    }
    /**
     * Patch patch an application
     * operationId: ApplicationService_Patch
     * Request URI: /api/v1/applications/{name}
     */
    async ApplicationService_Patch(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * ListResourceEvents returns a list of event resources
     * operationId: ApplicationService_ListResourceEvents
     * Request URI: /api/v1/applications/{name}/events
     */
    async ApplicationService_ListResourceEvents(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}/events`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            resourceNamespace: { value: params.parameter.resourceNamespace, explode: false },
            resourceName: { value: params.parameter.resourceName, explode: false },
            resourceUID: { value: params.parameter.resourceUID, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * PodLogs returns stream of log entries for the specified pod. Pod
     * operationId: ApplicationService_PodLogs2
     * Request URI: /api/v1/applications/{name}/logs
     */
    async ApplicationService_PodLogs2(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}/logs`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            namespace: { value: params.parameter.namespace, explode: false },
            podName: { value: params.parameter.podName, explode: false },
            container: { value: params.parameter.container, explode: false },
            sinceSeconds: { value: params.parameter.sinceSeconds, explode: false },
            "sinceTime.seconds": { value: params.parameter["sinceTime.seconds"], explode: false },
            "sinceTime.nanos": { value: params.parameter["sinceTime.nanos"], explode: false },
            tailLines: { value: params.parameter.tailLines, explode: false },
            follow: { value: params.parameter.follow, explode: false },
            untilTime: { value: params.parameter.untilTime, explode: false },
            filter: { value: params.parameter.filter, explode: false },
            kind: { value: params.parameter.kind, explode: false },
            group: { value: params.parameter.group, explode: false },
            resourceName: { value: params.parameter.resourceName, explode: false },
            previous: { value: params.parameter.previous, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * GetManifests returns application manifests
     * operationId: ApplicationService_GetManifests
     * Request URI: /api/v1/applications/{name}/manifests
     */
    async ApplicationService_GetManifests(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}/manifests`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            revision: { value: params.parameter.revision, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * TerminateOperation terminates the currently running operation
     * operationId: ApplicationService_TerminateOperation
     * Request URI: /api/v1/applications/{name}/operation
     */
    async ApplicationService_TerminateOperation(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}/operation`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * PodLogs returns stream of log entries for the specified pod. Pod
     * operationId: ApplicationService_PodLogs
     * Request URI: /api/v1/applications/{name}/pods/{podName}/logs
     */
    async ApplicationService_PodLogs(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}/pods/${params.parameter.podName}/logs`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            namespace: { value: params.parameter.namespace, explode: false },
            container: { value: params.parameter.container, explode: false },
            sinceSeconds: { value: params.parameter.sinceSeconds, explode: false },
            "sinceTime.seconds": { value: params.parameter["sinceTime.seconds"], explode: false },
            "sinceTime.nanos": { value: params.parameter["sinceTime.nanos"], explode: false },
            tailLines: { value: params.parameter.tailLines, explode: false },
            follow: { value: params.parameter.follow, explode: false },
            untilTime: { value: params.parameter.untilTime, explode: false },
            filter: { value: params.parameter.filter, explode: false },
            kind: { value: params.parameter.kind, explode: false },
            group: { value: params.parameter.group, explode: false },
            resourceName: { value: params.parameter.resourceName, explode: false },
            previous: { value: params.parameter.previous, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * GetResource returns single application resource
     * operationId: ApplicationService_GetResource
     * Request URI: /api/v1/applications/{name}/resource
     */
    async ApplicationService_GetResource(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}/resource`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            namespace: { value: params.parameter.namespace, explode: false },
            resourceName: { value: params.parameter.resourceName, explode: false },
            version: { value: params.parameter.version, explode: false },
            group: { value: params.parameter.group, explode: false },
            kind: { value: params.parameter.kind, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * PatchResource patch single application resource
     * operationId: ApplicationService_PatchResource
     * Request URI: /api/v1/applications/{name}/resource
     */
    async ApplicationService_PatchResource(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}/resource`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        const queryParameters = {
            namespace: { value: params.parameter.namespace, explode: false },
            resourceName: { value: params.parameter.resourceName, explode: false },
            version: { value: params.parameter.version, explode: false },
            group: { value: params.parameter.group, explode: false },
            kind: { value: params.parameter.kind, explode: false },
            patchType: { value: params.parameter.patchType, explode: false }
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, queryParameters, option);
    }
    /**
     * DeleteResource deletes a single application resource
     * operationId: ApplicationService_DeleteResource
     * Request URI: /api/v1/applications/{name}/resource
     */
    async ApplicationService_DeleteResource(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}/resource`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            namespace: { value: params.parameter.namespace, explode: false },
            resourceName: { value: params.parameter.resourceName, explode: false },
            version: { value: params.parameter.version, explode: false },
            group: { value: params.parameter.group, explode: false },
            kind: { value: params.parameter.kind, explode: false },
            force: { value: params.parameter.force, explode: false },
            orphan: { value: params.parameter.orphan, explode: false }
        };
        return this.apiClient.request("DELETE", url, headers, undefined, queryParameters, option);
    }
    /**
     * ListResourceActions returns list of resource actions
     * operationId: ApplicationService_ListResourceActions
     * Request URI: /api/v1/applications/{name}/resource/actions
     */
    async ApplicationService_ListResourceActions(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}/resource/actions`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            namespace: { value: params.parameter.namespace, explode: false },
            resourceName: { value: params.parameter.resourceName, explode: false },
            version: { value: params.parameter.version, explode: false },
            group: { value: params.parameter.group, explode: false },
            kind: { value: params.parameter.kind, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * RunResourceAction run resource action
     * operationId: ApplicationService_RunResourceAction
     * Request URI: /api/v1/applications/{name}/resource/actions
     */
    async ApplicationService_RunResourceAction(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}/resource/actions`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        const queryParameters = {
            namespace: { value: params.parameter.namespace, explode: false },
            resourceName: { value: params.parameter.resourceName, explode: false },
            version: { value: params.parameter.version, explode: false },
            group: { value: params.parameter.group, explode: false },
            kind: { value: params.parameter.kind, explode: false }
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, queryParameters, option);
    }
    /**
     * Get the meta-data (author, date, tags, message) for a specific revision of the application
     * operationId: ApplicationService_RevisionMetadata
     * Request URI: /api/v1/applications/{name}/revisions/{revision}/metadata
     */
    async ApplicationService_RevisionMetadata(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}/revisions/${params.parameter.revision}/metadata`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Rollback syncs an application to its target state
     * operationId: ApplicationService_Rollback
     * Request URI: /api/v1/applications/{name}/rollback
     */
    async ApplicationService_Rollback(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}/rollback`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * UpdateSpec updates an application spec
     * operationId: ApplicationService_UpdateSpec
     * Request URI: /api/v1/applications/{name}/spec
     */
    async ApplicationService_UpdateSpec(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}/spec`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        const queryParameters = {
            validate: { value: params.parameter.validate, explode: false }
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, queryParameters, option);
    }
    /**
     * Sync syncs an application to its target state
     * operationId: ApplicationService_Sync
     * Request URI: /api/v1/applications/{name}/sync
     */
    async ApplicationService_Sync(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}/sync`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get returns sync windows of the application
     * operationId: ApplicationService_GetApplicationSyncWindows
     * Request URI: /api/v1/applications/{name}/syncwindows
     */
    async ApplicationService_GetApplicationSyncWindows(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}/syncwindows`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * List all available repository certificates
     * operationId: CertificateService_ListCertificates
     * Request URI: /api/v1/certificates
     */
    async CertificateService_ListCertificates(params, option) {
        const url = this.baseUrl + `/api/v1/certificates`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            hostNamePattern: { value: params.parameter.hostNamePattern, explode: false },
            certType: { value: params.parameter.certType, explode: false },
            certSubType: { value: params.parameter.certSubType, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Creates repository certificates on the server
     * operationId: CertificateService_CreateCertificate
     * Request URI: /api/v1/certificates
     */
    async CertificateService_CreateCertificate(params, option) {
        const url = this.baseUrl + `/api/v1/certificates`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        const queryParameters = {
            upsert: { value: params.parameter.upsert, explode: false }
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, queryParameters, option);
    }
    /**
     * Delete the certificates that match the RepositoryCertificateQuery
     * operationId: CertificateService_DeleteCertificate
     * Request URI: /api/v1/certificates
     */
    async CertificateService_DeleteCertificate(params, option) {
        const url = this.baseUrl + `/api/v1/certificates`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            hostNamePattern: { value: params.parameter.hostNamePattern, explode: false },
            certType: { value: params.parameter.certType, explode: false },
            certSubType: { value: params.parameter.certSubType, explode: false }
        };
        return this.apiClient.request("DELETE", url, headers, undefined, queryParameters, option);
    }
    /**
     * List returns list of clusters
     * operationId: ClusterService_List
     * Request URI: /api/v1/clusters
     */
    async ClusterService_List(params, option) {
        const url = this.baseUrl + `/api/v1/clusters`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            server: { value: params.parameter.server, explode: false },
            name: { value: params.parameter.name, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create creates a cluster
     * operationId: ClusterService_Create
     * Request URI: /api/v1/clusters
     */
    async ClusterService_Create(params, option) {
        const url = this.baseUrl + `/api/v1/clusters`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        const queryParameters = {
            upsert: { value: params.parameter.upsert, explode: false }
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, queryParameters, option);
    }
    /**
     * Update updates a cluster
     * operationId: ClusterService_Update
     * Request URI: /api/v1/clusters/{cluster.server}
     */
    async ClusterService_Update(params, option) {
        const url = this.baseUrl + `/api/v1/clusters/${params.parameter["cluster.server"]}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        const queryParameters = {
            updatedFields: { value: params.parameter.updatedFields, explode: true }
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, queryParameters, option);
    }
    /**
     * Get returns a cluster by server address
     * operationId: ClusterService_Get
     * Request URI: /api/v1/clusters/{server}
     */
    async ClusterService_Get(params, option) {
        const url = this.baseUrl + `/api/v1/clusters/${params.parameter.server}`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            name: { value: params.parameter.name, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Delete deletes a cluster
     * operationId: ClusterService_Delete
     * Request URI: /api/v1/clusters/{server}
     */
    async ClusterService_Delete(params, option) {
        const url = this.baseUrl + `/api/v1/clusters/${params.parameter.server}`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            name: { value: params.parameter.name, explode: false }
        };
        return this.apiClient.request("DELETE", url, headers, undefined, queryParameters, option);
    }
    /**
     * InvalidateCache invalidates cluster cache
     * operationId: ClusterService_InvalidateCache
     * Request URI: /api/v1/clusters/{server}/invalidate-cache
     */
    async ClusterService_InvalidateCache(params, option) {
        const url = this.baseUrl + `/api/v1/clusters/${params.parameter.server}/invalidate-cache`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * RotateAuth rotates the bearer token used for a cluster
     * operationId: ClusterService_RotateAuth
     * Request URI: /api/v1/clusters/{server}/rotate-auth
     */
    async ClusterService_RotateAuth(params, option) {
        const url = this.baseUrl + `/api/v1/clusters/${params.parameter.server}/rotate-auth`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * List all available repository certificates
     * operationId: GPGKeyService_List
     * Request URI: /api/v1/gpgkeys
     */
    async GPGKeyService_List(params, option) {
        const url = this.baseUrl + `/api/v1/gpgkeys`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            keyID: { value: params.parameter.keyID, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create one or more GPG public keys in the server's configuration
     * operationId: GPGKeyService_Create
     * Request URI: /api/v1/gpgkeys
     */
    async GPGKeyService_Create(params, option) {
        const url = this.baseUrl + `/api/v1/gpgkeys`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        const queryParameters = {
            upsert: { value: params.parameter.upsert, explode: false }
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, queryParameters, option);
    }
    /**
     * Delete specified GPG public key from the server's configuration
     * operationId: GPGKeyService_Delete
     * Request URI: /api/v1/gpgkeys
     */
    async GPGKeyService_Delete(params, option) {
        const url = this.baseUrl + `/api/v1/gpgkeys`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            keyID: { value: params.parameter.keyID, explode: false }
        };
        return this.apiClient.request("DELETE", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get information about specified GPG public key from the server
     * operationId: GPGKeyService_Get
     * Request URI: /api/v1/gpgkeys/{keyID}
     */
    async GPGKeyService_Get(params, option) {
        const url = this.baseUrl + `/api/v1/gpgkeys/${params.parameter.keyID}`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * List returns list of projects
     * operationId: ProjectService_List
     * Request URI: /api/v1/projects
     */
    async ProjectService_List(params, option) {
        const url = this.baseUrl + `/api/v1/projects`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            name: { value: params.parameter.name, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a new project
     * operationId: ProjectService_Create
     * Request URI: /api/v1/projects
     */
    async ProjectService_Create(params, option) {
        const url = this.baseUrl + `/api/v1/projects`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get returns a project by name
     * operationId: ProjectService_Get
     * Request URI: /api/v1/projects/{name}
     */
    async ProjectService_Get(params, option) {
        const url = this.baseUrl + `/api/v1/projects/${params.parameter.name}`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete deletes a project
     * operationId: ProjectService_Delete
     * Request URI: /api/v1/projects/{name}
     */
    async ProjectService_Delete(params, option) {
        const url = this.baseUrl + `/api/v1/projects/${params.parameter.name}`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * GetDetailedProject returns a project that include project, global project and scoped resources by name
     * operationId: ProjectService_GetDetailedProject
     * Request URI: /api/v1/projects/{name}/detailed
     */
    async ProjectService_GetDetailedProject(params, option) {
        const url = this.baseUrl + `/api/v1/projects/${params.parameter.name}/detailed`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * ListEvents returns a list of project events
     * operationId: ProjectService_ListEvents
     * Request URI: /api/v1/projects/{name}/events
     */
    async ProjectService_ListEvents(params, option) {
        const url = this.baseUrl + `/api/v1/projects/${params.parameter.name}/events`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get returns a virtual project by name
     * operationId: ProjectService_GetGlobalProjects
     * Request URI: /api/v1/projects/{name}/globalprojects
     */
    async ProjectService_GetGlobalProjects(params, option) {
        const url = this.baseUrl + `/api/v1/projects/${params.parameter.name}/globalprojects`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * GetSchedulesState returns true if there are any active sync syncWindows
     * operationId: ProjectService_GetSyncWindowsState
     * Request URI: /api/v1/projects/{name}/syncwindows
     */
    async ProjectService_GetSyncWindowsState(params, option) {
        const url = this.baseUrl + `/api/v1/projects/${params.parameter.name}/syncwindows`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Update updates a project
     * operationId: ProjectService_Update
     * Request URI: /api/v1/projects/{project.metadata.name}
     */
    async ProjectService_Update(params, option) {
        const url = this.baseUrl + `/api/v1/projects/${params.parameter["project.metadata.name"]}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Create a new project token
     * operationId: ProjectService_CreateToken
     * Request URI: /api/v1/projects/{project}/roles/{role}/token
     */
    async ProjectService_CreateToken(params, option) {
        const url = this.baseUrl + `/api/v1/projects/${params.parameter.project}/roles/${params.parameter.role}/token`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete a new project token
     * operationId: ProjectService_DeleteToken
     * Request URI: /api/v1/projects/{project}/roles/{role}/token/{iat}
     */
    async ProjectService_DeleteToken(params, option) {
        const url = this.baseUrl + `/api/v1/projects/${params.parameter.project}/roles/${params.parameter.role}/token/${params.parameter.iat}`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            id: { value: params.parameter.id, explode: false }
        };
        return this.apiClient.request("DELETE", url, headers, undefined, queryParameters, option);
    }
    /**
     * ListRepositoryCredentials gets a list of all configured repository credential sets
     * operationId: RepoCredsService_ListRepositoryCredentials
     * Request URI: /api/v1/repocreds
     */
    async RepoCredsService_ListRepositoryCredentials(params, option) {
        const url = this.baseUrl + `/api/v1/repocreds`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            url: { value: params.parameter.url, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * CreateRepositoryCredentials creates a new repository credential set
     * operationId: RepoCredsService_CreateRepositoryCredentials
     * Request URI: /api/v1/repocreds
     */
    async RepoCredsService_CreateRepositoryCredentials(params, option) {
        const url = this.baseUrl + `/api/v1/repocreds`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        const queryParameters = {
            upsert: { value: params.parameter.upsert, explode: false }
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, queryParameters, option);
    }
    /**
     * UpdateRepositoryCredentials updates a repository credential set
     * operationId: RepoCredsService_UpdateRepositoryCredentials
     * Request URI: /api/v1/repocreds/{creds.url}
     */
    async RepoCredsService_UpdateRepositoryCredentials(params, option) {
        const url = this.baseUrl + `/api/v1/repocreds/${params.parameter["creds.url"]}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * DeleteRepositoryCredentials deletes a repository credential set from the configuration
     * operationId: RepoCredsService_DeleteRepositoryCredentials
     * Request URI: /api/v1/repocreds/{url}
     */
    async RepoCredsService_DeleteRepositoryCredentials(params, option) {
        const url = this.baseUrl + `/api/v1/repocreds/${params.parameter.url}`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * ListRepositories gets a list of all configured repositories
     * operationId: RepositoryService_ListRepositories
     * Request URI: /api/v1/repositories
     */
    async RepositoryService_ListRepositories(params, option) {
        const url = this.baseUrl + `/api/v1/repositories`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            repo: { value: params.parameter.repo, explode: false },
            forceRefresh: { value: params.parameter.forceRefresh, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * CreateRepository creates a new repository configuration
     * operationId: RepositoryService_CreateRepository
     * Request URI: /api/v1/repositories
     */
    async RepositoryService_CreateRepository(params, option) {
        const url = this.baseUrl + `/api/v1/repositories`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        const queryParameters = {
            upsert: { value: params.parameter.upsert, explode: false },
            credsOnly: { value: params.parameter.credsOnly, explode: false }
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, queryParameters, option);
    }
    /**
     * UpdateRepository updates a repository configuration
     * operationId: RepositoryService_UpdateRepository
     * Request URI: /api/v1/repositories/{repo.repo}
     */
    async RepositoryService_UpdateRepository(params, option) {
        const url = this.baseUrl + `/api/v1/repositories/${params.parameter["repo.repo"]}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get returns a repository or its credentials
     * operationId: RepositoryService_Get
     * Request URI: /api/v1/repositories/{repo}
     */
    async RepositoryService_Get(params, option) {
        const url = this.baseUrl + `/api/v1/repositories/${params.parameter.repo}`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            forceRefresh: { value: params.parameter.forceRefresh, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * DeleteRepository deletes a repository from the configuration
     * operationId: RepositoryService_DeleteRepository
     * Request URI: /api/v1/repositories/{repo}
     */
    async RepositoryService_DeleteRepository(params, option) {
        const url = this.baseUrl + `/api/v1/repositories/${params.parameter.repo}`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            forceRefresh: { value: params.parameter.forceRefresh, explode: false }
        };
        return this.apiClient.request("DELETE", url, headers, undefined, queryParameters, option);
    }
    /**
     * ListApps returns list of apps in the repo
     * operationId: RepositoryService_ListApps
     * Request URI: /api/v1/repositories/{repo}/apps
     */
    async RepositoryService_ListApps(params, option) {
        const url = this.baseUrl + `/api/v1/repositories/${params.parameter.repo}/apps`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            revision: { value: params.parameter.revision, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * GetHelmCharts returns list of helm charts in the specified repository
     * operationId: RepositoryService_GetHelmCharts
     * Request URI: /api/v1/repositories/{repo}/helmcharts
     */
    async RepositoryService_GetHelmCharts(params, option) {
        const url = this.baseUrl + `/api/v1/repositories/${params.parameter.repo}/helmcharts`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            forceRefresh: { value: params.parameter.forceRefresh, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * operationId: RepositoryService_ListRefs
     * Request URI: /api/v1/repositories/{repo}/refs
     */
    async RepositoryService_ListRefs(params, option) {
        const url = this.baseUrl + `/api/v1/repositories/${params.parameter.repo}/refs`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            forceRefresh: { value: params.parameter.forceRefresh, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * ValidateAccess validates access to a repository with given parameters
     * operationId: RepositoryService_ValidateAccess
     * Request URI: /api/v1/repositories/{repo}/validate
     */
    async RepositoryService_ValidateAccess(params, option) {
        const url = this.baseUrl + `/api/v1/repositories/${params.parameter.repo}/validate`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        const queryParameters = {
            username: { value: params.parameter.username, explode: false },
            password: { value: params.parameter.password, explode: false },
            sshPrivateKey: { value: params.parameter.sshPrivateKey, explode: false },
            insecure: { value: params.parameter.insecure, explode: false },
            tlsClientCertData: { value: params.parameter.tlsClientCertData, explode: false },
            tlsClientCertKey: { value: params.parameter.tlsClientCertKey, explode: false },
            type: { value: params.parameter.type, explode: false },
            name: { value: params.parameter.name, explode: false },
            enableOci: { value: params.parameter.enableOci, explode: false },
            githubAppPrivateKey: { value: params.parameter.githubAppPrivateKey, explode: false },
            githubAppID: { value: params.parameter.githubAppID, explode: false },
            githubAppInstallationID: { value: params.parameter.githubAppInstallationID, explode: false },
            githubAppEnterpriseBaseUrl: { value: params.parameter.githubAppEnterpriseBaseUrl, explode: false },
            proxy: { value: params.parameter.proxy, explode: false },
            project: { value: params.parameter.project, explode: false }
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, queryParameters, option);
    }
    /**
     * GetAppDetails returns application details by given path
     * operationId: RepositoryService_GetAppDetails
     * Request URI: /api/v1/repositories/{source.repoURL}/appdetails
     */
    async RepositoryService_GetAppDetails(params, option) {
        const url = this.baseUrl + `/api/v1/repositories/${params.parameter["source.repoURL"]}/appdetails`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Create a new JWT for authentication and set a cookie if using HTTP
     * operationId: SessionService_Create
     * Request URI: /api/v1/session
     */
    async SessionService_Create(params, option) {
        const url = this.baseUrl + `/api/v1/session`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete an existing JWT cookie if using HTTP
     * operationId: SessionService_Delete
     * Request URI: /api/v1/session
     */
    async SessionService_Delete(option) {
        const url = this.baseUrl + `/api/v1/session`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Get the current user's info
     * operationId: SessionService_GetUserInfo
     * Request URI: /api/v1/session/userinfo
     */
    async SessionService_GetUserInfo(option) {
        const url = this.baseUrl + `/api/v1/session/userinfo`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get returns Argo CD settings
     * operationId: SettingsService_Get
     * Request URI: /api/v1/settings
     */
    async SettingsService_Get(option) {
        const url = this.baseUrl + `/api/v1/settings`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Watch returns stream of application change events
     * operationId: ApplicationService_Watch
     * Request URI: /api/v1/stream/applications
     */
    async ApplicationService_Watch(params, option) {
        const url = this.baseUrl + `/api/v1/stream/applications`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            name: { value: params.parameter.name, explode: false },
            refresh: { value: params.parameter.refresh, explode: false },
            project: { value: params.parameter.project, explode: true },
            resourceVersion: { value: params.parameter.resourceVersion, explode: false },
            selector: { value: params.parameter.selector, explode: false },
            repo: { value: params.parameter.repo, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Watch returns stream of application resource tree
     * operationId: ApplicationService_WatchResourceTree
     * Request URI: /api/v1/stream/applications/{applicationName}/resource-tree
     */
    async ApplicationService_WatchResourceTree(params, option) {
        const url = this.baseUrl + `/api/v1/stream/applications/${params.parameter.applicationName}/resource-tree`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            namespace: { value: params.parameter.namespace, explode: false },
            name: { value: params.parameter.name, explode: false },
            version: { value: params.parameter.version, explode: false },
            group: { value: params.parameter.group, explode: false },
            kind: { value: params.parameter.kind, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Version returns version information of the API server
     * operationId: VersionService_Version
     * Request URI: /api/version
     */
    async VersionService_Version(option) {
        const url = this.baseUrl + `/api/version`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
}
exports.Client = Client;
