// 
// Generated by @himenon/openapi-typescript-code-generator v0.13.2
// 
// OpenApi : 3.0.0
// 
// 
export class Client {
    constructor(apiClient, baseUrl) {
        this.apiClient = apiClient;
        this.baseUrl = baseUrl.replace(/\/$/, "");
    }
    /**
     * ListAccounts returns the list of accounts
     * operationId: ListAccounts
     * Request URI: /api/v1/account
     */
    async ListAccounts(option) {
        const url = this.baseUrl + `/api/v1/account`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * CanI checks if the current account has permission to perform an action
     * operationId: CanI
     * Request URI: /api/v1/account/can-i/{resource}/{action}/{subresource}
     */
    async CanI(params, option) {
        const url = this.baseUrl + `/api/v1/account/can-i/${params.parameter.resource}/${params.parameter.action}/${params.parameter.subresource}`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * UpdatePassword updates an account's password to a new value
     * operationId: UpdatePassword
     * Request URI: /api/v1/account/password
     */
    async UpdatePassword(params, option) {
        const url = this.baseUrl + `/api/v1/account/password`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * GetAccount returns an account
     * operationId: GetAccount
     * Request URI: /api/v1/account/{name}
     */
    async GetAccount(params, option) {
        const url = this.baseUrl + `/api/v1/account/${params.parameter.name}`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * CreateToken creates a token
     * operationId: CreateToken
     * Request URI: /api/v1/account/{name}/token
     */
    async CreateToken(params, option) {
        const url = this.baseUrl + `/api/v1/account/${params.parameter.name}/token`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * DeleteToken deletes a token
     * operationId: DeleteToken
     * Request URI: /api/v1/account/{name}/token/{id}
     */
    async DeleteToken(params, option) {
        const url = this.baseUrl + `/api/v1/account/${params.parameter.name}/token/${params.parameter.id}`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List returns list of applications
     * operationId: List
     * Request URI: /api/v1/applications
     */
    async List(params, option) {
        const url = this.baseUrl + `/api/v1/applications`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            name: { value: params.parameter.name, explode: false },
            refresh: { value: params.parameter.refresh, explode: false },
            project: { value: params.parameter.project, explode: true },
            resourceVersion: { value: params.parameter.resourceVersion, explode: false },
            selector: { value: params.parameter.selector, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create creates an application
     * operationId: Create
     * Request URI: /api/v1/applications
     */
    async Create(params, option) {
        const url = this.baseUrl + `/api/v1/applications`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Update updates an application
     * operationId: Update
     * Request URI: /api/v1/applications/{application.metadata.name}
     */
    async Update(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter["application.metadata.name"]}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * ManagedResources returns list of managed resources
     * operationId: ManagedResources
     * Request URI: /api/v1/applications/{applicationName}/managed-resources
     */
    async ManagedResources(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.applicationName}/managed-resources`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            namespace: { value: params.parameter.namespace, explode: false },
            name: { value: params.parameter.name, explode: false },
            version: { value: params.parameter.version, explode: false },
            group: { value: params.parameter.group, explode: false },
            kind: { value: params.parameter.kind, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * ResourceTree returns resource tree
     * operationId: ResourceTree
     * Request URI: /api/v1/applications/{applicationName}/resource-tree
     */
    async ResourceTree(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.applicationName}/resource-tree`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            namespace: { value: params.parameter.namespace, explode: false },
            name: { value: params.parameter.name, explode: false },
            version: { value: params.parameter.version, explode: false },
            group: { value: params.parameter.group, explode: false },
            kind: { value: params.parameter.kind, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get returns an application by name
     * operationId: Get
     * Request URI: /api/v1/applications/{name}
     */
    async Get(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            refresh: { value: params.parameter.refresh, explode: false },
            project: { value: params.parameter.project, explode: true },
            resourceVersion: { value: params.parameter.resourceVersion, explode: false },
            selector: { value: params.parameter.selector, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Delete deletes an application
     * operationId: Delete
     * Request URI: /api/v1/applications/{name}
     */
    async Delete(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            cascade: { value: params.parameter.cascade, explode: false }
        };
        return this.apiClient.request("DELETE", url, headers, undefined, queryParameters, option);
    }
    /**
     * Patch patch an application
     * operationId: Patch
     * Request URI: /api/v1/applications/{name}
     */
    async Patch(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * ListResourceEvents returns a list of event resources
     * operationId: ListResourceEvents
     * Request URI: /api/v1/applications/{name}/events
     */
    async ListResourceEvents(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}/events`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            resourceNamespace: { value: params.parameter.resourceNamespace, explode: false },
            resourceName: { value: params.parameter.resourceName, explode: false },
            resourceUID: { value: params.parameter.resourceUID, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * GetManifests returns application manifests
     * operationId: GetManifests
     * Request URI: /api/v1/applications/{name}/manifests
     */
    async GetManifests(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}/manifests`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            revision: { value: params.parameter.revision, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * TerminateOperation terminates the currently running operation
     * operationId: TerminateOperation
     * Request URI: /api/v1/applications/{name}/operation
     */
    async TerminateOperation(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}/operation`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * PodLogs returns stream of log entries for the specified pod. Pod
     * operationId: PodLogs
     * Request URI: /api/v1/applications/{name}/pods/{podName}/logs
     */
    async PodLogs(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}/pods/${params.parameter.podName}/logs`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            namespace: { value: params.parameter.namespace, explode: false },
            container: { value: params.parameter.container, explode: false },
            sinceSeconds: { value: params.parameter.sinceSeconds, explode: false },
            "sinceTime.seconds": { value: params.parameter["sinceTime.seconds"], explode: false },
            "sinceTime.nanos": { value: params.parameter["sinceTime.nanos"], explode: false },
            tailLines: { value: params.parameter.tailLines, explode: false },
            follow: { value: params.parameter.follow, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * GetResource returns single application resource
     * operationId: GetResource
     * Request URI: /api/v1/applications/{name}/resource
     */
    async GetResource(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}/resource`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            namespace: { value: params.parameter.namespace, explode: false },
            resourceName: { value: params.parameter.resourceName, explode: false },
            version: { value: params.parameter.version, explode: false },
            group: { value: params.parameter.group, explode: false },
            kind: { value: params.parameter.kind, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * PatchResource patch single application resource
     * operationId: PatchResource
     * Request URI: /api/v1/applications/{name}/resource
     */
    async PatchResource(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}/resource`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * DeleteResource deletes a single application resource
     * operationId: DeleteResource
     * Request URI: /api/v1/applications/{name}/resource
     */
    async DeleteResource(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}/resource`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            namespace: { value: params.parameter.namespace, explode: false },
            resourceName: { value: params.parameter.resourceName, explode: false },
            version: { value: params.parameter.version, explode: false },
            group: { value: params.parameter.group, explode: false },
            kind: { value: params.parameter.kind, explode: false },
            force: { value: params.parameter.force, explode: false }
        };
        return this.apiClient.request("DELETE", url, headers, undefined, queryParameters, option);
    }
    /**
     * ListResourceActions returns list of resource actions
     * operationId: ListResourceActions
     * Request URI: /api/v1/applications/{name}/resource/actions
     */
    async ListResourceActions(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}/resource/actions`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            namespace: { value: params.parameter.namespace, explode: false },
            resourceName: { value: params.parameter.resourceName, explode: false },
            version: { value: params.parameter.version, explode: false },
            group: { value: params.parameter.group, explode: false },
            kind: { value: params.parameter.kind, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * RunResourceAction run resource action
     * operationId: RunResourceAction
     * Request URI: /api/v1/applications/{name}/resource/actions
     */
    async RunResourceAction(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}/resource/actions`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get the meta-data (author, date, tags, message) for a specific revision of the application
     * operationId: RevisionMetadata
     * Request URI: /api/v1/applications/{name}/revisions/{revision}/metadata
     */
    async RevisionMetadata(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}/revisions/${params.parameter.revision}/metadata`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Rollback syncs an application to its target state
     * operationId: Rollback
     * Request URI: /api/v1/applications/{name}/rollback
     */
    async Rollback(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}/rollback`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * UpdateSpec updates an application spec
     * operationId: UpdateSpec
     * Request URI: /api/v1/applications/{name}/spec
     */
    async UpdateSpec(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}/spec`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Sync syncs an application to its target state
     * operationId: Sync
     * Request URI: /api/v1/applications/{name}/sync
     */
    async Sync(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}/sync`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get returns sync windows of the application
     * operationId: GetApplicationSyncWindows
     * Request URI: /api/v1/applications/{name}/syncwindows
     */
    async GetApplicationSyncWindows(params, option) {
        const url = this.baseUrl + `/api/v1/applications/${params.parameter.name}/syncwindows`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * List all available repository certificates
     * operationId: ListCertificates
     * Request URI: /api/v1/certificates
     */
    async ListCertificates(params, option) {
        const url = this.baseUrl + `/api/v1/certificates`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            hostNamePattern: { value: params.parameter.hostNamePattern, explode: false },
            certType: { value: params.parameter.certType, explode: false },
            certSubType: { value: params.parameter.certSubType, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Creates repository certificates on the server
     * operationId: CreateCertificate
     * Request URI: /api/v1/certificates
     */
    async CreateCertificate(params, option) {
        const url = this.baseUrl + `/api/v1/certificates`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete the certificates that match the RepositoryCertificateQuery
     * operationId: DeleteCertificate
     * Request URI: /api/v1/certificates
     */
    async DeleteCertificate(params, option) {
        const url = this.baseUrl + `/api/v1/certificates`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            hostNamePattern: { value: params.parameter.hostNamePattern, explode: false },
            certType: { value: params.parameter.certType, explode: false },
            certSubType: { value: params.parameter.certSubType, explode: false }
        };
        return this.apiClient.request("DELETE", url, headers, undefined, queryParameters, option);
    }
    /**
     * List returns list of clusters
     * operationId: ListMixin3
     * Request URI: /api/v1/clusters
     */
    async ListMixin3(params, option) {
        const url = this.baseUrl + `/api/v1/clusters`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            server: { value: params.parameter.server, explode: false },
            name: { value: params.parameter.name, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create creates a cluster
     * operationId: CreateMixin3
     * Request URI: /api/v1/clusters
     */
    async CreateMixin3(params, option) {
        const url = this.baseUrl + `/api/v1/clusters`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Update updates a cluster
     * operationId: UpdateMixin3
     * Request URI: /api/v1/clusters/{cluster.server}
     */
    async UpdateMixin3(params, option) {
        const url = this.baseUrl + `/api/v1/clusters/${params.parameter["cluster.server"]}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get returns a cluster by server address
     * operationId: GetMixin3
     * Request URI: /api/v1/clusters/{server}
     */
    async GetMixin3(params, option) {
        const url = this.baseUrl + `/api/v1/clusters/${params.parameter.server}`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            name: { value: params.parameter.name, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Delete deletes a cluster
     * operationId: DeleteMixin3
     * Request URI: /api/v1/clusters/{server}
     */
    async DeleteMixin3(params, option) {
        const url = this.baseUrl + `/api/v1/clusters/${params.parameter.server}`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            name: { value: params.parameter.name, explode: false }
        };
        return this.apiClient.request("DELETE", url, headers, undefined, queryParameters, option);
    }
    /**
     * InvalidateCache invalidates cluster cache
     * operationId: InvalidateCache
     * Request URI: /api/v1/clusters/{server}/invalidate-cache
     */
    async InvalidateCache(params, option) {
        const url = this.baseUrl + `/api/v1/clusters/${params.parameter.server}/invalidate-cache`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * RotateAuth rotates the bearer token used for a cluster
     * operationId: RotateAuth
     * Request URI: /api/v1/clusters/{server}/rotate-auth
     */
    async RotateAuth(params, option) {
        const url = this.baseUrl + `/api/v1/clusters/${params.parameter.server}/rotate-auth`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * List all available repository certificates
     * operationId: ListMixin4
     * Request URI: /api/v1/gpgkeys
     */
    async ListMixin4(params, option) {
        const url = this.baseUrl + `/api/v1/gpgkeys`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            keyID: { value: params.parameter.keyID, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create one or more GPG public keys in the server's configuration
     * operationId: CreateMixin4
     * Request URI: /api/v1/gpgkeys
     */
    async CreateMixin4(params, option) {
        const url = this.baseUrl + `/api/v1/gpgkeys`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete specified GPG public key from the server's configuration
     * operationId: DeleteMixin4
     * Request URI: /api/v1/gpgkeys
     */
    async DeleteMixin4(params, option) {
        const url = this.baseUrl + `/api/v1/gpgkeys`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            keyID: { value: params.parameter.keyID, explode: false }
        };
        return this.apiClient.request("DELETE", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get information about specified GPG public key from the server
     * operationId: GetMixin4
     * Request URI: /api/v1/gpgkeys/{keyID}
     */
    async GetMixin4(params, option) {
        const url = this.baseUrl + `/api/v1/gpgkeys/${params.parameter.keyID}`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * List returns list of projects
     * operationId: ListMixin5
     * Request URI: /api/v1/projects
     */
    async ListMixin5(params, option) {
        const url = this.baseUrl + `/api/v1/projects`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            name: { value: params.parameter.name, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a new project
     * operationId: CreateMixin5
     * Request URI: /api/v1/projects
     */
    async CreateMixin5(params, option) {
        const url = this.baseUrl + `/api/v1/projects`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get returns a project by name
     * operationId: GetMixin5
     * Request URI: /api/v1/projects/{name}
     */
    async GetMixin5(params, option) {
        const url = this.baseUrl + `/api/v1/projects/${params.parameter.name}`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete deletes a project
     * operationId: DeleteMixin5
     * Request URI: /api/v1/projects/{name}
     */
    async DeleteMixin5(params, option) {
        const url = this.baseUrl + `/api/v1/projects/${params.parameter.name}`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * ListEvents returns a list of project events
     * operationId: ListEvents
     * Request URI: /api/v1/projects/{name}/events
     */
    async ListEvents(params, option) {
        const url = this.baseUrl + `/api/v1/projects/${params.parameter.name}/events`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get returns a virtual project by name
     * operationId: GetGlobalProjects
     * Request URI: /api/v1/projects/{name}/globalprojects
     */
    async GetGlobalProjects(params, option) {
        const url = this.baseUrl + `/api/v1/projects/${params.parameter.name}/globalprojects`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * GetSchedulesState returns true if there are any active sync syncWindows
     * operationId: GetSyncWindowsState
     * Request URI: /api/v1/projects/{name}/syncwindows
     */
    async GetSyncWindowsState(params, option) {
        const url = this.baseUrl + `/api/v1/projects/${params.parameter.name}/syncwindows`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Update updates a project
     * operationId: UpdateMixin5
     * Request URI: /api/v1/projects/{project.metadata.name}
     */
    async UpdateMixin5(params, option) {
        const url = this.baseUrl + `/api/v1/projects/${params.parameter["project.metadata.name"]}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Create a new project token
     * operationId: CreateTokenMixin5
     * Request URI: /api/v1/projects/{project}/roles/{role}/token
     */
    async CreateTokenMixin5(params, option) {
        const url = this.baseUrl + `/api/v1/projects/${params.parameter.project}/roles/${params.parameter.role}/token`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete a new project token
     * operationId: DeleteTokenMixin5
     * Request URI: /api/v1/projects/{project}/roles/{role}/token/{iat}
     */
    async DeleteTokenMixin5(params, option) {
        const url = this.baseUrl + `/api/v1/projects/${params.parameter.project}/roles/${params.parameter.role}/token/${params.parameter.iat}`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            id: { value: params.parameter.id, explode: false }
        };
        return this.apiClient.request("DELETE", url, headers, undefined, queryParameters, option);
    }
    /**
     * ListRepositoryCredentials gets a list of all configured repository credential sets
     * operationId: ListRepositoryCredentials
     * Request URI: /api/v1/repocreds
     */
    async ListRepositoryCredentials(params, option) {
        const url = this.baseUrl + `/api/v1/repocreds`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            url: { value: params.parameter.url, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * CreateRepositoryCredentials creates a new repository credential set
     * operationId: CreateRepositoryCredentials
     * Request URI: /api/v1/repocreds
     */
    async CreateRepositoryCredentials(params, option) {
        const url = this.baseUrl + `/api/v1/repocreds`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * UpdateRepositoryCredentials updates a repository credential set
     * operationId: UpdateRepositoryCredentials
     * Request URI: /api/v1/repocreds/{creds.url}
     */
    async UpdateRepositoryCredentials(params, option) {
        const url = this.baseUrl + `/api/v1/repocreds/${params.parameter["creds.url"]}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * DeleteRepositoryCredentials deletes a repository credential set from the configuration
     * operationId: DeleteRepositoryCredentials
     * Request URI: /api/v1/repocreds/{url}
     */
    async DeleteRepositoryCredentials(params, option) {
        const url = this.baseUrl + `/api/v1/repocreds/${params.parameter.url}`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * ListRepositories gets a list of all configured repositories
     * operationId: ListRepositories
     * Request URI: /api/v1/repositories
     */
    async ListRepositories(params, option) {
        const url = this.baseUrl + `/api/v1/repositories`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            repo: { value: params.parameter.repo, explode: false },
            forceRefresh: { value: params.parameter.forceRefresh, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * CreateRepository creates a new repository configuration
     * operationId: CreateRepository
     * Request URI: /api/v1/repositories
     */
    async CreateRepository(params, option) {
        const url = this.baseUrl + `/api/v1/repositories`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * UpdateRepository updates a repository configuration
     * operationId: UpdateRepository
     * Request URI: /api/v1/repositories/{repo.repo}
     */
    async UpdateRepository(params, option) {
        const url = this.baseUrl + `/api/v1/repositories/${params.parameter["repo.repo"]}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get returns a repository or its credentials
     * operationId: GetMixin7
     * Request URI: /api/v1/repositories/{repo}
     */
    async GetMixin7(params, option) {
        const url = this.baseUrl + `/api/v1/repositories/${params.parameter.repo}`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            forceRefresh: { value: params.parameter.forceRefresh, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * DeleteRepository deletes a repository from the configuration
     * operationId: DeleteRepository
     * Request URI: /api/v1/repositories/{repo}
     */
    async DeleteRepository(params, option) {
        const url = this.baseUrl + `/api/v1/repositories/${params.parameter.repo}`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            forceRefresh: { value: params.parameter.forceRefresh, explode: false }
        };
        return this.apiClient.request("DELETE", url, headers, undefined, queryParameters, option);
    }
    /**
     * ListApps returns list of apps in the repe
     * operationId: ListApps
     * Request URI: /api/v1/repositories/{repo}/apps
     */
    async ListApps(params, option) {
        const url = this.baseUrl + `/api/v1/repositories/${params.parameter.repo}/apps`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            revision: { value: params.parameter.revision, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * GetHelmCharts returns list of helm charts in the specified repository
     * operationId: GetHelmCharts
     * Request URI: /api/v1/repositories/{repo}/helmcharts
     */
    async GetHelmCharts(params, option) {
        const url = this.baseUrl + `/api/v1/repositories/${params.parameter.repo}/helmcharts`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            forceRefresh: { value: params.parameter.forceRefresh, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * operationId: ListRefs
     * Request URI: /api/v1/repositories/{repo}/refs
     */
    async ListRefs(params, option) {
        const url = this.baseUrl + `/api/v1/repositories/${params.parameter.repo}/refs`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            forceRefresh: { value: params.parameter.forceRefresh, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * ValidateAccess validates access to a repository with given parameters
     * operationId: ValidateAccess
     * Request URI: /api/v1/repositories/{repo}/validate
     */
    async ValidateAccess(params, option) {
        const url = this.baseUrl + `/api/v1/repositories/${params.parameter.repo}/validate`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * GetAppDetails returns application details by given path
     * operationId: GetAppDetails
     * Request URI: /api/v1/repositories/{source.repoURL}/appdetails
     */
    async GetAppDetails(params, option) {
        const url = this.baseUrl + `/api/v1/repositories/${params.parameter["source.repoURL"]}/appdetails`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Create a new JWT for authentication and set a cookie if using HTTP
     * operationId: CreateMixin8
     * Request URI: /api/v1/session
     */
    async CreateMixin8(params, option) {
        const url = this.baseUrl + `/api/v1/session`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json"
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete an existing JWT cookie if using HTTP
     * operationId: DeleteMixin8
     * Request URI: /api/v1/session
     */
    async DeleteMixin8(option) {
        const url = this.baseUrl + `/api/v1/session`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Get the current user's info
     * operationId: GetUserInfo
     * Request URI: /api/v1/session/userinfo
     */
    async GetUserInfo(option) {
        const url = this.baseUrl + `/api/v1/session/userinfo`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get returns Argo CD settings
     * operationId: GetMixin10
     * Request URI: /api/v1/settings
     */
    async GetMixin10(option) {
        const url = this.baseUrl + `/api/v1/settings`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Watch returns stream of application change events
     * operationId: Watch
     * Request URI: /api/v1/stream/applications
     */
    async Watch(params, option) {
        const url = this.baseUrl + `/api/v1/stream/applications`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            name: { value: params.parameter.name, explode: false },
            refresh: { value: params.parameter.refresh, explode: false },
            project: { value: params.parameter.project, explode: true },
            resourceVersion: { value: params.parameter.resourceVersion, explode: false },
            selector: { value: params.parameter.selector, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Watch returns stream of application resource tree
     * operationId: WatchResourceTree
     * Request URI: /api/v1/stream/applications/{applicationName}/resource-tree
     */
    async WatchResourceTree(params, option) {
        const url = this.baseUrl + `/api/v1/stream/applications/${params.parameter.applicationName}/resource-tree`;
        const headers = {
            Accept: "application/json"
        };
        const queryParameters = {
            namespace: { value: params.parameter.namespace, explode: false },
            name: { value: params.parameter.name, explode: false },
            version: { value: params.parameter.version, explode: false },
            group: { value: params.parameter.group, explode: false },
            kind: { value: params.parameter.kind, explode: false }
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Version returns version information of the API server
     * operationId: Version
     * Request URI: /api/version
     */
    async Version(option) {
        const url = this.baseUrl + `/api/version`;
        const headers = {
            Accept: "application/json"
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
}
